import { select, json, geoPath, geoEquirectangular } from 'd3';
import { feature } from 'topojson';

// Determining SVG from the HTML code
const SVG = select('svg');

// Creating new geoEquirectangular object which are used to generate as well as to project paths
const projection = geoEquirectangular();
const pathCreator = geoPath().projection(projection);

SVG.append('path')
	.attr('class','sphere')
	.attr('d', pathCreator({type: 'Sphere'}));

// Fetching data from end points then formating it to project.
json('https://cdn.jsdelivr.net/npm/world-atlas@2/countries-110m.json')
  .then(data => {
  	// Extracting all the countries to upload them on page from the data
    const MAP = feature(data, data.objects.countries);
  	// Passing extracted countries in form of data to generate the paths.
    SVG.selectAll('path').data(MAP.features)
      .enter().append('path')
        .attr('class', 'country')
        .attr('d', pathCreator);
  });